#######################################################################
##### Part of the VortexGE Configuration Script                   #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THIS SCRIPT TO FAIL #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

#######################################################################
##### Functions for Checking X11
#######################################################################

##### Check if the specified file is exist (and print a message if not found)
FindFilePM()
{
  if [[ ! -e $1 ]]; then
    echo ''
    echo -n $_COLOR_RED"  NOT FOUND: $1"
    export $2='#ERROR'
  fi
}

##### Check if the specified feature (the given file) is exist,
##### disable the use of the feature if the needed file is not exist
DetectFeature()
{
  if [[ $3 != 'D' ]]; then
    if [[ -e $1 ]]; then
      export $2='Y'
    else
      export $2='N'
    fi
  fi
}

##### Find where the X11 folders are located in the system
FindX11()
{
  ##### Generate possible X11 directory names
  local __Loc__
  local __Use__
  local __Slc__
  for __Loc__ in $X11DirLoc; do
    for __Use__ in $X11VTBUse; do
      __Slc__="$__Slc__ $__Loc__/$__Use__"
    done
    __Slc__="$__Slc__ $__Loc__"
  done

  ##### Check if any of the generated directory names above
  ##### actually contains X11 headers and libraries
  local __Prf__
  local __Inc__
  local __Lib__
  for __Loc__ in $__Slc__; do
    for __Prf__ in lib64 lib32 lib; do
     if [[ -d $__Loc__/include/X11 ]] &&
        [[ -d $__Loc__/$__Prf__/X11     ]]; then
        __Inc__=$__Loc__/include
        __Lib__=$__Loc__/$__Prf__
        break
     fi
    done
   if [[ $__Inc__ != '' ]] && [[ $__Lib__ != '' ]]; then
     break
   fi
  done
  if [[ $__Inc__ == '' ]] || [[ $__Lib__ == '' ]]; then
    return
  fi

  ##### Check for required features
  local __Err__
  FindFilePM $__Inc__/X11/xpm.h         __Err__
  FindFilePM $__Inc__/X11/Xlib.h        __Err__
  FindFilePM $__Inc__/X11/Xatom.h       __Err__
  FindFilePM $__Inc__/X11/Xutil.h       __Err__
  FindFilePM $__Inc__/X11/keysym.h      __Err__
  FindFilePM $__Inc__/X11/cursorfont.h  __Err__
  if [[ $__Err__ == '#ERROR' ]]; then
    export $1=$__Err__
    export $2=$__Err__
    echo ''
    return
  fi

  ##### Check for optional features
  DetectFeature "$__Inc__/X11/extensions/xf86vmode.h" UseXF86VM $UseXF86VM
  DetectFeature "$__Inc__/X11/extensions/XShm.h"      UseXShmEx $UseXShmEx
  DetectFeature "$__Inc__/X11/Xmu/WinUtil.h"          UseXMuExt $UseXMuExt
  DetectFeature "$__Lib__/libXxf86vm.so"              Xxf86vmso $Xxf86vmso

  ##### Return the X11 headers and libraries directories
  export $1=$__Inc__
  export $2=$__Lib__
}
