// ############################################################################################
//  SoundBuffer.cc
//  Implementation of CSoundBuffer class using dummy (NULL) audio system
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This library is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################

// VortexGE headers
#include "ADMYSoundBuffer.h"


namespace vge {

//
// The dummy sound buffer implementation
//
CDummySoundBuffer::~CDummySoundBuffer() throw()
{
}

void CDummySoundBuffer::Play(bool bLooping)
{
  UNUSED_PARAM(bLooping);
}

void CDummySoundBuffer::ConvertMonoToStereo(bool bSilentRightChannel)
{
  UNUSED_PARAM(bSilentRightChannel);
}

void CDummySoundBuffer::AdjustAmplitude(float fLeftGain, float fRightGain)
{
  UNUSED_PARAMS_2(fLeftGain, fRightGain);
}

void CDummySoundBuffer::LoadRAW(const CDataSource &source, ERawFormat eFormat, int32_t n32Frequency)
{
  UNUSED_PARAMS_3(source, eFormat, n32Frequency);
}

void CDummySoundBuffer::LoadWAV(const CDataSource &source)
{
  UNUSED_PARAM(source);
}

void CDummySoundBuffer::LoadVSW(const CDataSource &source)
{
  UNUSED_PARAM(source);
}

void CDummySoundBuffer::SaveVSW(const CDataSink &sink) const
{
  UNUSED_PARAM(sink);
}

} // namespace vge
