/** \file AOSSSoundBuffer.h */
// ############################################################################################
//  AOSSSoundBuffer.h
//  Definition & implementation of CSoundBuffer class using OSS audio system
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This library is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################
#include "../../VConfig.h"
#if !defined(_AUDIO_ENVIRONMENT___PCM_OSS___AOSS_SOUND_BUFFER_H_) && defined(__USE_OSS_AUDIO__)
#define _AUDIO_ENVIRONMENT___PCM_OSS___AOSS_SOUND_BUFFER_H_

// VortexGE headers
#include "../NonDummySoundBufferBaseClass.h"
#include "AOSSEnvironment.h"


namespace vge {

  //!
  //! \brief OSS audio sound-buffer class
  //!
  //! \api pretty stable
  class VGE_EXPORT COssSoundBuffer : public CSoundBufferCImp {
    public:
      virtual ~COssSoundBuffer() throw();
      // Playback functions
      virtual void Play(bool bLooping = false);
      virtual bool IsPlaying() const;
      virtual void Stop();

      // Friend classes
      friend class COssAudioEnv;

    protected:
      // Make sure user can't construct this class directly
      inline COssSoundBuffer() {}
  };

} // namespace vge
#endif
